Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Reservation_station_vhdl_body.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Reservation_station_vhdl_body.cpp	(revision 56)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Reservation_station_vhdl_body.cpp	(revision 69)
@@ -18,11 +18,296 @@
 namespace reservation_station {
 
-
 #undef  FUNCTION
 #define FUNCTION "Reservation_station::vhdl_body"
   void Reservation_station::vhdl_body (Vhdl * & vhdl)
   {
+    string range_retire, range_insert;
+
+    if (_param->_size_queue == 1)
+      range_insert = "(0)";
+    else
+      range_insert = "(conv_integer(internal_INSERT_SLOT"+std_logic_range(log2(_param->_size_queue))+"))";
+
     log_printf(FUNC,Reservation_station,FUNCTION,"Begin");
-    vhdl->set_body ("");
+
+    vhdl->set_body ("-----------------------------------");
+    vhdl->set_body ("-- interface 'INSERT'");
+    vhdl->set_body ("-----------------------------------");
+    vhdl->set_body ("");
+    vhdl->set_body ("     out_INSERT_ACK          <= not internal_FULL;");
+    vhdl->set_body ("internal_INSERT_TRANSACTION  <= not internal_FULL and in_INSERT_VAL;");
+    
+    vhdl->set_body ("internal_INSERT_SLOT         <=");
+    for (uint32_t i=0; i<_param->_size_queue; i++)
+      {
+	vhdl->set_body ("\t"+std_logic_conv(log2(_param->_size_queue+1),i)+" when reg_VAL("+toString(i)+")='0' else");
+      }
+    vhdl->set_body ("\t"+std_logic_conv(log2(_param->_size_queue+1),_param->_size_queue)+";");
+
+    vhdl->set_body ("");
+    vhdl->set_body ("-----------------------------------");
+    vhdl->set_body ("-- interface 'RETIRE'");
+    vhdl->set_body ("-----------------------------------");
+    vhdl->set_body ("");
+    for (uint32_t i=0; i<_param->_nb_inst_retire; i++)
+      vhdl->set_body ("internal_RETIRE_TRANSACTION_"+toString(i)+"<= not internal_RETIRE_SLOT_"+toString(i)+std_logic_range(log2(_param->_size_queue)+1,log2(_param->_size_queue),log2(_param->_size_queue))+" and in_RETIRE_"+toString(i)+"_ACK;");
+    vhdl->set_body ("");
+
+    uint32_t nb_slot_scan = _param->_size_queue-_param->_nb_inst_retire+1;
+    for (uint32_t i=0; i<_param->_nb_inst_retire; i++)
+      {
+	vhdl->set_body ("internal_RETIRE_SLOT_"+toString(i)+"       <= ");
+	for (uint32_t j=i; j<nb_slot_scan+i; j++)
+	  {
+	    vhdl->set_body ("\t"+std_logic_conv(log2(_param->_size_queue+1),j)+" when");
+	    for (uint32_t k=0; k<i; k++)
+	      {
+		vhdl->set_body ("\t\tnot (internal_RETIRE_SLOT_"+toString(k)+" = "+std_logic_conv(log2(_param->_size_queue),j)+std_logic_range(log2(_param->_size_queue))+") and");
+	      }
+	    vhdl->set_body ("\t\t(reg_VAL        ("+toString(j)+")='1') and");
+	    vhdl->set_body ("\t\t(reg_DATA_RA_VAL("+toString(j)+")='1') and");
+	    vhdl->set_body ("\t\t(reg_DATA_RB_VAL("+toString(j)+")='1') and");
+	    vhdl->set_body ("\t\t(reg_DATA_RC_VAL("+toString(j)+")='1') else");
+	  }
+	vhdl->set_body ("\t"+std_logic_conv(log2(_param->_size_queue+1),_param->_size_queue)+";");
+	vhdl->set_body ("");
+      }
+
+    for (uint32_t i=0; i<_param->_nb_inst_retire; i++)
+      {
+	if (_param->_size_queue == 1)
+	  range_retire = "(0)";
+	else
+	  range_retire = "(conv_integer(internal_RETIRE_SLOT_"+toString(i)+std_logic_range(log2(_param->_size_queue)+1,log2(_param->_size_queue)-1,0)+"))";
+
+	vhdl->set_body ("out_RETIRE_"+toString(i)+"_VAL             <= not internal_RETIRE_SLOT_"+toString(i)+std_logic_range(log2(_param->_size_queue)+1,log2(_param->_size_queue),log2(_param->_size_queue))+";");
+	if (_param->_have_port_context_id)			    
+	vhdl->set_body ("out_RETIRE_"+toString(i)+"_CONTEXT_ID      <= reg_CONTEXT_ID   "+range_retire+";");
+	if (_param->_have_port_front_end_id)			    
+	vhdl->set_body ("out_RETIRE_"+toString(i)+"_FRONT_END_ID    <= reg_FRONT_END_ID "+range_retire+";");
+	if (_param->_have_port_ooo_engine_id)			    
+	vhdl->set_body ("out_RETIRE_"+toString(i)+"_OOO_ENGINE_ID   <= reg_OOO_ENGINE_ID"+range_retire+";");
+	if (_param->_have_port_rob_id)				    
+	vhdl->set_body ("out_RETIRE_"+toString(i)+"_ROB_ID          <= reg_ROB_ID       "+range_retire+";");
+	vhdl->set_body ("out_RETIRE_"+toString(i)+"_OPERATION       <= reg_OPERATION    "+range_retire+";");
+	vhdl->set_body ("out_RETIRE_"+toString(i)+"_TYPE            <= reg_TYPE         "+range_retire+";");
+	vhdl->set_body ("out_RETIRE_"+toString(i)+"_HAS_IMMEDIAT    <= reg_HAS_IMMEDIAT "+range_retire+";");
+	vhdl->set_body ("out_RETIRE_"+toString(i)+"_IMMEDIAT        <= reg_IMMEDIAT     "+range_retire+";");
+	vhdl->set_body ("out_RETIRE_"+toString(i)+"_DATA_RA         <= reg_DATA_RA      "+range_retire+";");
+	vhdl->set_body ("out_RETIRE_"+toString(i)+"_DATA_RB         <= reg_DATA_RB      "+range_retire+";");
+	vhdl->set_body ("out_RETIRE_"+toString(i)+"_DATA_RC         <= reg_DATA_RC      "+range_retire+";");
+	vhdl->set_body ("out_RETIRE_"+toString(i)+"_WRITE_RD        <= reg_WRITE_RD     "+range_retire+";");
+	vhdl->set_body ("out_RETIRE_"+toString(i)+"_NUM_REG_RD      <= reg_NUM_REG_RD   "+range_retire+";");
+	vhdl->set_body ("out_RETIRE_"+toString(i)+"_WRITE_RE        <= reg_WRITE_RE     "+range_retire+";");
+	vhdl->set_body ("out_RETIRE_"+toString(i)+"_NUM_REG_RE      <= reg_NUM_REG_RE   "+range_retire+";");
+	vhdl->set_body ("");
+      }
+
+//     vhdl->set_body ("-----------------------------------");
+//     vhdl->set_body ("-- flags");
+//     vhdl->set_body ("-----------------------------------");
+//     vhdl->set_body ("");
+//     vhdl->set_body ("internal_EMPTY <=");
+//     for (uint32_t i=_param->_size_queue-1; i>0; i--)
+//       vhdl->set_body ("\tnot reg_VAL ("+toString(i)+") and");
+//     vhdl->set_body ("\tnot reg_VAL (0);");
+//     vhdl->set_body ("internal_FULL  <=");
+//     for (uint32_t i=_param->_size_queue-1; i>0; i--)
+//       vhdl->set_body ("\t    reg_VAL ("+toString(i)+") and");
+//     vhdl->set_body ("\t    reg_VAL (0);");
+
+    vhdl->set_body ("");
+    vhdl->set_body ("-----------------------------------");
+    vhdl->set_body ("-- transition");
+    vhdl->set_body ("-----------------------------------");
+    vhdl->set_body ("");
+    vhdl->set_body ("transition: process (in_CLOCK)");
+    vhdl->set_body ("begin  -- process transition");
+    vhdl->set_body ("\tif in_CLOCK'event and in_CLOCK = '1' then");
+    vhdl->set_body ("");
+    vhdl->set_body ("\t\tif (in_NRESET = '0') then");    
+    for (uint32_t i=0; i<_param->_size_queue; i++)
+      {
+	vhdl->set_body ("\t\t\treg_VAL ("+toString(i)+")<= '0';");
+      }
+    vhdl->set_body ("\t\telse");
+
+
+    vhdl->set_body ("");
+    vhdl->set_body ("\t\t\t-----------------------------------");
+    vhdl->set_body ("\t\t\t-- bypass");
+    vhdl->set_body ("\t\t\t-----------------------------------");
+    vhdl->set_body ("");
+    vhdl->set_body ("\t\t\t-- interface : 'GPR_WRITE'");
+    for (uint32_t i=0; i<_param->_nb_gpr_write; i++)
+      {
+	vhdl->set_body ("\t\t\tif (in_GPR_WRITE_"+toString(i)+"_VAL = '1') then");
+	vhdl->set_body ("\t\t\t\t-- scan all entry (don't test if entry is valid)");
+	for (uint32_t j=0; j<_param->_size_queue; j++)
+	  {
+	    if (_param->_have_port_ooo_engine_id)
+	      vhdl->set_body ("\t\t\t\tif (in_GPR_WRITE_"+toString(i)+"_OOO_ENGINE_ID = reg_OOO_ENGINE_ID ("+toString(j)+")) then");
+	    vhdl->set_body ("\t\t\t\t\tif (in_GPR_WRITE_"+toString(i)+"_NUM_REG = reg_NUM_REG_RA ("+toString(j)+")) then");
+	    vhdl->set_body ("\t\t\t\t\t\treg_DATA_RA_VAL ("+toString(j)+") <= '1';");
+	    vhdl->set_body ("\t\t\t\t\t\treg_DATA_RA     ("+toString(j)+") <= in_GPR_WRITE_"+toString(i)+"_DATA;");
+	    vhdl->set_body ("\t\t\t\t\tend if;");    
+
+	    vhdl->set_body ("\t\t\t\t\tif (in_GPR_WRITE_"+toString(i)+"_NUM_REG = reg_NUM_REG_RB ("+toString(j)+")) then");
+	    vhdl->set_body ("\t\t\t\t\t\treg_DATA_RB_VAL ("+toString(j)+") <= '1';");
+	    vhdl->set_body ("\t\t\t\t\t\treg_DATA_RB     ("+toString(j)+") <= in_GPR_WRITE_"+toString(i)+"_DATA;");
+	    vhdl->set_body ("\t\t\t\t\tend if;");    
+
+	    if (_param->_have_port_ooo_engine_id)
+	      vhdl->set_body ("\t\t\t\tend if;");    
+	  }
+	vhdl->set_body ("\t\t\tend if;");    
+      }
+
+    vhdl->set_body ("\t\t\t-- interface : 'SPR_WRITE'");
+    for (uint32_t i=0; i<_param->_nb_spr_write; i++)
+      {
+	vhdl->set_body ("\t\t\tif (in_SPR_WRITE_"+toString(i)+"_VAL = '1') then");
+	vhdl->set_body ("\t\t\t\t-- scan all entry (don't test if entry is valid)");
+	for (uint32_t j=0; j<_param->_size_queue; j++)
+	  {
+	    if (_param->_have_port_ooo_engine_id)
+	      vhdl->set_body ("\t\t\t\tif (in_SPR_WRITE_"+toString(i)+"_OOO_ENGINE_ID = reg_OOO_ENGINE_ID ("+toString(j)+")) then");
+	    vhdl->set_body ("\t\t\t\t\tif (in_SPR_WRITE_"+toString(i)+"_NUM_REG = reg_NUM_REG_RC ("+toString(j)+")) then");
+	    vhdl->set_body ("\t\t\t\t\t\treg_DATA_RC_VAL ("+toString(j)+") <= '1';");
+	    vhdl->set_body ("\t\t\t\t\t\treg_DATA_RC     ("+toString(j)+") <= in_SPR_WRITE_"+toString(i)+"_DATA;");
+	    vhdl->set_body ("\t\t\t\t\tend if;");    
+
+	    if (_param->_have_port_ooo_engine_id)
+	      vhdl->set_body ("\t\t\t\tend if;");    
+	  }
+	vhdl->set_body ("\t\t\tend if;");    
+      }
+
+    vhdl->set_body ("\t\t\t-- interface : 'BYPASS_WRITE_GPR'");
+    for (uint32_t i=0; i<_param->_nb_bypass_write; i++)
+      {
+	vhdl->set_body ("\t\t\tif (in_BYPASS_WRITE_"+toString(i)+"_GPR_VAL = '1') then");
+	vhdl->set_body ("\t\t\t\t-- scan all entry (don't test if entry is valid)");
+	for (uint32_t j=0; j<_param->_size_queue; j++)
+	  {
+	    if (_param->_have_port_ooo_engine_id)
+	      vhdl->set_body ("\t\t\t\tif (in_BYPASS_WRITE_"+toString(i)+"_OOO_ENGINE_ID = reg_OOO_ENGINE_ID ("+toString(j)+")) then");
+	    vhdl->set_body ("\t\t\t\t\tif (in_BYPASS_WRITE_"+toString(i)+"_GPR_NUM_REG = reg_NUM_REG_RA ("+toString(j)+")) then");
+	    vhdl->set_body ("\t\t\t\t\t\treg_DATA_RA_VAL ("+toString(j)+") <= '1';");
+	    vhdl->set_body ("\t\t\t\t\t\treg_DATA_RA     ("+toString(j)+") <= in_BYPASS_WRITE_"+toString(i)+"_GPR_DATA;");
+	    vhdl->set_body ("\t\t\t\t\tend if;");    
+
+	    vhdl->set_body ("\t\t\t\t\tif (in_BYPASS_WRITE_"+toString(i)+"_GPR_NUM_REG = reg_NUM_REG_RB ("+toString(j)+")) then");
+	    vhdl->set_body ("\t\t\t\t\t\treg_DATA_RB_VAL ("+toString(j)+") <= '1';");
+	    vhdl->set_body ("\t\t\t\t\t\treg_DATA_RB     ("+toString(j)+") <= in_BYPASS_WRITE_"+toString(i)+"_GPR_DATA;");
+	    vhdl->set_body ("\t\t\t\t\tend if;");    
+
+	    if (_param->_have_port_ooo_engine_id)
+	      vhdl->set_body ("\t\t\t\tend if;");    
+	  }
+	vhdl->set_body ("\t\t\tend if;");    
+      }
+
+    vhdl->set_body ("\t\t\t-- interface : 'BYPASS_WRITE_SPR'");
+    for (uint32_t i=0; i<_param->_nb_bypass_write; i++)
+      {
+	vhdl->set_body ("\t\t\tif (in_BYPASS_WRITE_"+toString(i)+"_SPR_VAL = '1') then");
+	vhdl->set_body ("\t\t\t\t-- scan all entry (don't test if entry is valid)");
+	for (uint32_t j=0; j<_param->_size_queue; j++)
+	  {
+	    if (_param->_have_port_ooo_engine_id)
+	      vhdl->set_body ("\t\t\t\tif (in_BYPASS_WRITE_"+toString(i)+"_OOO_ENGINE_ID = reg_OOO_ENGINE_ID ("+toString(j)+")) then");
+	    vhdl->set_body ("\t\t\t\t\tif (in_BYPASS_WRITE_"+toString(i)+"_SPR_NUM_REG = reg_NUM_REG_RC ("+toString(j)+")) then");
+	    vhdl->set_body ("\t\t\t\t\t\treg_DATA_RC_VAL ("+toString(j)+") <= '1';");
+	    vhdl->set_body ("\t\t\t\t\t\treg_DATA_RC     ("+toString(j)+") <= in_BYPASS_WRITE_"+toString(i)+"_SPR_DATA;");
+	    vhdl->set_body ("\t\t\t\t\tend if;");    
+
+	    if (_param->_have_port_ooo_engine_id)
+	      vhdl->set_body ("\t\t\t\tend if;");    
+	  }
+	vhdl->set_body ("\t\t\tend if;");    
+      }
+
+    vhdl->set_body ("\t\t\t-- interface : 'BYPASS_MEMORY_GPR'");
+    for (uint32_t i=0; i<_param->_nb_bypass_memory; i++)
+      {
+	vhdl->set_body ("\t\t\tif (in_BYPASS_MEMORY_"+toString(i)+"_VAL = '1') then");
+	vhdl->set_body ("\t\t\t\t-- scan all entry (don't test if entry is valid)");
+	for (uint32_t j=0; j<_param->_size_queue; j++)
+	  {
+	    if (_param->_have_port_ooo_engine_id)
+	      vhdl->set_body ("\t\t\t\tif (in_BYPASS_MEMORY_"+toString(i)+"_OOO_ENGINE_ID = reg_OOO_ENGINE_ID ("+toString(j)+")) then");
+	    vhdl->set_body ("\t\t\t\t\tif (in_BYPASS_MEMORY_"+toString(i)+"_NUM_REG = reg_NUM_REG_RA ("+toString(j)+")) then");
+	    vhdl->set_body ("\t\t\t\t\t\treg_DATA_RA_VAL ("+toString(j)+") <= '1';");
+	    vhdl->set_body ("\t\t\t\t\t\treg_DATA_RA     ("+toString(j)+") <= in_BYPASS_MEMORY_"+toString(i)+"_DATA;");
+	    vhdl->set_body ("\t\t\t\t\tend if;");    
+
+	    vhdl->set_body ("\t\t\t\t\tif (in_BYPASS_MEMORY_"+toString(i)+"_NUM_REG = reg_NUM_REG_RB ("+toString(j)+")) then");
+	    vhdl->set_body ("\t\t\t\t\t\treg_DATA_RB_VAL ("+toString(j)+") <= '1';");
+	    vhdl->set_body ("\t\t\t\t\t\treg_DATA_RB     ("+toString(j)+") <= in_BYPASS_MEMORY_"+toString(i)+"_DATA;");
+	    vhdl->set_body ("\t\t\t\t\tend if;");    
+
+	    if (_param->_have_port_ooo_engine_id)
+	      vhdl->set_body ("\t\t\t\tend if;");    
+	  }
+	vhdl->set_body ("\t\t\tend if;");    
+      }
+
+    vhdl->set_body ("");
+    vhdl->set_body ("\t\t\t-- interface : 'INSERT'");
+    vhdl->set_body ("\t\t\tif (internal_INSERT_TRANSACTION = '1') then");
+
+
+
+    vhdl->set_body ("\t\t\t\treg_VAL           "+range_insert+" <= '1';");
+
+    if (_param->_have_port_context_id)
+    vhdl->set_body ("\t\t\t\treg_CONTEXT_ID    "+range_insert+" <= in_INSERT_CONTEXT_ID   ;");
+    if (_param->_have_port_front_end_id)
+    vhdl->set_body ("\t\t\t\treg_FRONT_END_ID  "+range_insert+" <= in_INSERT_FRONT_END_ID ;");
+    if (_param->_have_port_ooo_engine_id)
+    vhdl->set_body ("\t\t\t\treg_OOO_ENGINE_ID "+range_insert+" <= in_INSERT_OOO_ENGINE_ID;");
+    if (_param->_have_port_rob_id)
+    vhdl->set_body ("\t\t\t\treg_ROB_ID        "+range_insert+" <= in_INSERT_ROB_ID       ;");
+    vhdl->set_body ("\t\t\t\treg_OPERATION     "+range_insert+" <= in_INSERT_OPERATION    ;");
+    vhdl->set_body ("\t\t\t\treg_TYPE          "+range_insert+" <= in_INSERT_TYPE         ;");
+    vhdl->set_body ("\t\t\t\treg_HAS_IMMEDIAT  "+range_insert+" <= in_INSERT_HAS_IMMEDIAT ;");
+    vhdl->set_body ("\t\t\t\treg_IMMEDIAT      "+range_insert+" <= in_INSERT_IMMEDIAT     ;");
+    vhdl->set_body ("\t\t\t\treg_NUM_REG_RA    "+range_insert+" <= in_INSERT_NUM_REG_RA   ;");
+    vhdl->set_body ("\t\t\t\treg_DATA_RA_VAL   "+range_insert+" <= in_INSERT_DATA_RA_VAL  ;");
+    vhdl->set_body ("\t\t\t\treg_DATA_RA       "+range_insert+" <= in_INSERT_DATA_RA      ;");
+    vhdl->set_body ("\t\t\t\treg_NUM_REG_RB    "+range_insert+" <= in_INSERT_NUM_REG_RB   ;");
+    vhdl->set_body ("\t\t\t\treg_DATA_RB_VAL   "+range_insert+" <= in_INSERT_DATA_RB_VAL  ;");
+    vhdl->set_body ("\t\t\t\treg_DATA_RB       "+range_insert+" <= in_INSERT_DATA_RB      ;");
+    vhdl->set_body ("\t\t\t\treg_NUM_REG_RC    "+range_insert+" <= in_INSERT_NUM_REG_RC   ;");
+    vhdl->set_body ("\t\t\t\treg_DATA_RC_VAL   "+range_insert+" <= in_INSERT_DATA_RC_VAL  ;");
+    vhdl->set_body ("\t\t\t\treg_DATA_RC       "+range_insert+" <= in_INSERT_DATA_RC      ;");
+    vhdl->set_body ("\t\t\t\treg_WRITE_RD      "+range_insert+" <= in_INSERT_WRITE_RD     ;");
+    vhdl->set_body ("\t\t\t\treg_NUM_REG_RD    "+range_insert+" <= in_INSERT_NUM_REG_RD   ;");
+    vhdl->set_body ("\t\t\t\treg_WRITE_RE      "+range_insert+" <= in_INSERT_WRITE_RE     ;");
+    vhdl->set_body ("\t\t\t\treg_NUM_REG_RE    "+range_insert+" <= in_INSERT_NUM_REG_RE   ;");
+    vhdl->set_body ("\t\t\tend if;");    
+
+    vhdl->set_body ("");
+    vhdl->set_body ("\t\t\t-- interface : 'RETIRE'");
+    for (uint32_t i=0; i<_param->_nb_inst_retire; i++)
+      {
+	if (_param->_size_queue == 1)
+	  range_retire = "(0)";
+	else
+	  range_retire = "(conv_integer(internal_RETIRE_SLOT_"+toString(i)+std_logic_range(log2(_param->_size_queue)+1,log2(_param->_size_queue)-1,0)+"))";
+
+	vhdl->set_body ("\t\t\tif (internal_RETIRE_TRANSACTION_"+toString(i)+" = '1') then");
+	
+	vhdl->set_body ("\t\t\t\treg_VAL "+range_retire+" <= '0';");
+	vhdl->set_body ("\t\t\tend if;");    
+      }
+
+    vhdl->set_body ("");
+    vhdl->set_body ("\t\tend if;");
+    vhdl->set_body ("");
+    vhdl->set_body ("\tend if;");
+    vhdl->set_body ("end process transition;");
+
     log_printf(FUNC,Reservation_station,FUNCTION,"End");
   };
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Reservation_station_vhdl_declaration.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Reservation_station_vhdl_declaration.cpp	(revision 56)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Reservation_station_vhdl_declaration.cpp	(revision 69)
@@ -24,4 +24,63 @@
   {
     log_printf(FUNC,Reservation_station,FUNCTION,"Begin");
+
+    vhdl->set_type ("Tcontrol        ","array (" + toString(_param->_size_queue-1) + " downto 0) of " + std_logic(1));
+    if (_param->_have_port_context_id)            
+    vhdl->set_type ("Tcontext_id     ","array (" + toString(_param->_size_queue-1) + " downto 0) of " + std_logic(_param->_size_context_id));
+    if (_param->_have_port_front_end_id)          
+    vhdl->set_type ("Tfront_end_id   ","array (" + toString(_param->_size_queue-1) + " downto 0) of " + std_logic(_param->_size_front_end_id));
+    if (_param->_have_port_ooo_engine_id)         
+    vhdl->set_type ("Tooo_engine_id  ","array (" + toString(_param->_size_queue-1) + " downto 0) of " + std_logic(_param->_size_ooo_engine_id));
+    if (_param->_have_port_rob_id)	          
+    vhdl->set_type ("Trob_id         ","array (" + toString(_param->_size_queue-1) + " downto 0) of " + std_logic(_param->_size_rob_id));
+    vhdl->set_type ("Toperation      ","array (" + toString(_param->_size_queue-1) + " downto 0) of " + std_logic(_param->_size_operation));
+    vhdl->set_type ("Ttype           ","array (" + toString(_param->_size_queue-1) + " downto 0) of " + std_logic(_param->_size_type));
+    vhdl->set_type ("Tgeneral_data   ","array (" + toString(_param->_size_queue-1) + " downto 0) of " + std_logic(_param->_size_general_data));
+    vhdl->set_type ("Tspecial_data   ","array (" + toString(_param->_size_queue-1) + " downto 0) of " + std_logic(_param->_size_special_data));    
+    vhdl->set_type ("Tgeneral_address","array (" + toString(_param->_size_queue-1) + " downto 0) of " + std_logic(_param->_size_general_register));
+    vhdl->set_type ("Tspecial_address","array (" + toString(_param->_size_queue-1) + " downto 0) of " + std_logic(_param->_size_special_register));    
+
+    vhdl->set_signal("reg_VAL                     ","Tcontrol");
+    if (_param->_have_port_context_id)            
+    vhdl->set_signal("reg_CONTEXT_ID              ","Tcontext_id");
+    if (_param->_have_port_front_end_id)          
+    vhdl->set_signal("reg_FRONT_END_ID            ","Tfront_end_id");
+    if (_param->_have_port_ooo_engine_id)         
+    vhdl->set_signal("reg_OOO_ENGINE_ID           ","Tooo_engine_id");
+    if (_param->_have_port_rob_id)	          
+    vhdl->set_signal("reg_ROB_ID                  ","Trob_id");
+    vhdl->set_signal("reg_OPERATION               ","Toperation");
+    vhdl->set_signal("reg_TYPE                    ","Ttype");
+    vhdl->set_signal("reg_HAS_IMMEDIAT            ","Tcontrol");
+    vhdl->set_signal("reg_IMMEDIAT                ","Tgeneral_data");
+    vhdl->set_signal("reg_NUM_REG_RA              ","Tgeneral_address");
+    vhdl->set_signal("reg_DATA_RA_VAL             ","Tcontrol");
+    vhdl->set_signal("reg_DATA_RA                 ","Tgeneral_data");
+    vhdl->set_signal("reg_NUM_REG_RB              ","Tgeneral_address");
+    vhdl->set_signal("reg_DATA_RB_VAL             ","Tcontrol");
+    vhdl->set_signal("reg_DATA_RB                 ","Tgeneral_data");
+    vhdl->set_signal("reg_NUM_REG_RC              ","Tspecial_address");
+    vhdl->set_signal("reg_DATA_RC_VAL             ","Tcontrol");
+    vhdl->set_signal("reg_DATA_RC                 ","Tspecial_data");
+    vhdl->set_signal("reg_WRITE_RD                ","Tcontrol");
+    vhdl->set_signal("reg_NUM_REG_RD              ","Tgeneral_address");
+    vhdl->set_signal("reg_WRITE_RE                ","Tcontrol");
+    vhdl->set_signal("reg_NUM_REG_RE              ","Tspecial_address");
+
+    if (_param->_size_queue == 1)
+      vhdl->set_alias(" internal_FULL               ",1,"internal_INSERT_SLOT","");
+    else
+      vhdl->set_alias(" internal_FULL               ",1,"internal_INSERT_SLOT","("+toString(log2(_param->_size_queue))+")");
+//  vhdl->set_signal("internal_EMPTY              ",1);
+
+    vhdl->set_signal("internal_INSERT_TRANSACTION ",1);
+    vhdl->set_signal("internal_INSERT_SLOT        ",log2(_param->_size_queue)+1);
+
+    
+    for (uint32_t i=0; i<_param->_nb_inst_retire; i++)
+      {
+	vhdl->set_signal("internal_RETIRE_TRANSACTION_"+toString(i),1);
+	vhdl->set_signal("internal_RETIRE_SLOT_"+toString(i)+"      ",log2(_param->_size_queue)+1);
+      }
     log_printf(FUNC,Reservation_station,FUNCTION,"End");
   };
@@ -33,5 +92,4 @@
 }; // end namespace multi_execute_loop
 }; // end namespace core
-
 }; // end namespace behavioural
 }; // end namespace morpheo              
